SystemOrganization addCategory: #TusLibros!

TestCase subclass: #MerchantProcessorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!MerchantProcessorTest methodsFor: 'Merchant Processor Tests' stamp: 'EmilianoMenendezEzequielNicolas 6/1/2013 21:22'!
creditCardExpiredResult

	^ CreditCardTransactionResult newWithCode: '1' andMessage: 'EXPIRED_CARD'.! !

!MerchantProcessorTest methodsFor: 'Merchant Processor Tests' stamp: 'EmilianoMenendezEzequielNicolas 6/1/2013 21:22'!
okResult

	^ CreditCardTransactionResult ok.! !

!MerchantProcessorTest methodsFor: 'Merchant Processor Tests' stamp: 'EmilianoMenendezEzequielNicolas 6/1/2013 21:19'!
testDebit0AmountShouldReturnError

	| merchantProcessor creditCard responseFromMerchantProcessor|
	
	merchantProcessor := MerchantProcessorStub new.
	creditCard := CreditCard newWithNumber: '1234' andOwner: 'Homero Simpson' andExpirationDate: Date tomorrow.
	
	responseFromMerchantProcessor := merchantProcessor debit: 0 fromCard: creditCard.
	
	self assert: responseFromMerchantProcessor equals: self wrongAmountResult.! !

!MerchantProcessorTest methodsFor: 'Merchant Processor Tests' stamp: 'EmilianoMenendezEzequielNicolas 6/1/2013 21:18'!
testDebitNegativeAmountShouldReturnError

	| merchantProcessor creditCard responseFromMerchantProcessor|
	
	merchantProcessor := MerchantProcessorStub new.
	creditCard := CreditCard newWithNumber: '1234' andOwner: 'Homero Simpson' andExpirationDate: Date tomorrow.
	
	responseFromMerchantProcessor := merchantProcessor debit: -100.50 fromCard: creditCard.
	
	self assert: responseFromMerchantProcessor equals: self wrongAmountResult.! !

!MerchantProcessorTest methodsFor: 'Merchant Processor Tests' stamp: 'EmilianoMenendezEzequielNicolas 6/1/2013 21:19'!
testDebitWithDataOKShouldReturnOK

	| merchantProcessor creditCard responseFromMerchantProcessor|
	
	merchantProcessor := MerchantProcessorStub new.
	creditCard := CreditCard newWithNumber: '1234' andOwner: 'Homero Simpson' andExpirationDate: Date tomorrow.
	
	responseFromMerchantProcessor := merchantProcessor debit: 100.50 fromCard: creditCard.
	
	self assert: responseFromMerchantProcessor equals: self okResult.! !

!MerchantProcessorTest methodsFor: 'Merchant Processor Tests' stamp: 'EmilianoMenendezEzequielNicolas 6/1/2013 21:20'!
testDebitWithExpiredCardShouldReturnError

	| merchantProcessor creditCard responseFromMerchantProcessor|
	
	merchantProcessor := MerchantProcessorStub new.
	creditCard := CreditCard newWithNumber: '5678' andOwner: 'Marge Simpson' andExpirationDate: Date yesterday.
	
	responseFromMerchantProcessor := merchantProcessor debit: 100.50 fromCard: creditCard.
	
	self assert: responseFromMerchantProcessor equals: self creditCardExpiredResult.! !

!MerchantProcessorTest methodsFor: 'Merchant Processor Tests' stamp: 'EmilianoMenendezEzequielNicolas 6/1/2013 21:22'!
wrongAmountResult

	^ CreditCardTransactionResult newWithCode: '1' andMessage: 'AMOUNT_MUST_BE_GREATER_THAN_ZERO'.! !

TestCase subclass: #TusLibrosTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!TusLibrosTest methodsFor: 'cashier' stamp: 'EmilianoMenendezEzequielNicols 6/3/2013 20:24'!
cajeroWith: aResult

	|aMerchantProcessor|
	
	aMerchantProcessor := MerchantProcessorStub newWith: aResult.
	
	^Cashier newWith: aMerchantProcessor ! !

!TusLibrosTest methodsFor: 'cart tests' stamp: 'EmilianoMenendezEzequielNicols 5/29/2013 21:46'!
carrito
	
		^ Cart newCartWithCatalog: self catalogo! !

!TusLibrosTest methodsFor: 'cart tests' stamp: 'EmilianoMenendezEzequielNicols 5/31/2013 19:00'!
carritoConUnLibro
     | book1 catalog |
	book1 := '3514564564674'.
	catalog := self catalogo.
	
	^ (Cart newCartWithCatalog: catalog) add: book1! !

!TusLibrosTest methodsFor: 'cart tests' stamp: 'EmilianoMenendezEzequielNicols 5/31/2013 19:07'!
catalogo
	| book1 book2 catalog book3 |
	
	book1 := '3514564564674'.
	book2 := '6464564564564'.
	book3:= '35145645646748'.	
	
	catalog := Dictionary new.
	catalog at: book1 put: 2.
	catalog at: book2 put: 25.
	catalog at: book3 put: 27.
	
	^ catalog! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielNicols 6/5/2013 21:23'!
securityGuard
	
	^SecurityGuard newWith: self userRegistry.  ! !

!TusLibrosTest methodsFor: 'Credit Card Tests' stamp: 'EmilianoMenendezEzequielNicols 6/3/2013 20:47'!
tarjetaNoVencida
	
	CreditCard newWithNumber: '32442342423' andOwner: 'pepe' andExpirationDate: (Date today + 60)! !

!TusLibrosTest methodsFor: 'Credit Card Tests' stamp: 'EmilianoMenendezEzequielNicols 6/3/2013 20:54'!
tarjetaVencida
	
	^CreditCard newWithNumber: '32442342423' andOwner: 'pepe' andExpirationDate: Date yesterday! !

!TusLibrosTest methodsFor: 'cart tests' stamp: 'EmilianoMenendezEzequielNicols 5/27/2013 20:44'!
test01AllCartsAreCreatedEmpty
	"Todo carrito se crea vaco"

	self assert: self carrito isEmpty.! !

!TusLibrosTest methodsFor: 'cart tests' stamp: 'EmilianoMenendezEzequielNicols 5/31/2013 19:01'!
test02AfterAddingTheFirstBookCartShouldNotBeEmpty
	"Luego de agregarle libros, el carrito no est vaco"

	self deny: (self carrito add: '6464564564564' withQuantity: 1) isEmpty.! !

!TusLibrosTest methodsFor: 'cart tests' stamp: 'EmilianoMenendezEzequielNicols 5/31/2013 19:05'!
test03AfterAddingMoreBooksCartShouldStillNotBeEmpty
	"Luego de agregarle libros, el carrito no est vaco"

	| aBook aCartWithBooks|
	
	aBook:= '3514564564674'.
	
	aCartWithBooks:=  self carrito add: aBook withQuantity: 1.
	
	self deny: (aCartWithBooks add: aBook withQuantity: 1) isEmpty.
	! !

!TusLibrosTest methodsFor: 'cart tests' stamp: 'EmilianoMenendezEzequielNicols 5/29/2013 19:54'!
test03BooksAddedShouldAppearWithTheirQuantities
	
	| aBook aCartWithBooks|
	
	aBook:= '35145645646748'.
	
	aCartWithBooks:=  self carrito add: aBook withQuantity: 1.
	aCartWithBooks add: aBook withQuantity: 1.
		
	self assert: (aCartWithBooks hasItem: aBook  withQuantity: 2)! !

!TusLibrosTest methodsFor: 'cart tests' stamp: 'EmilianoMenendezEzequielNicols 5/29/2013 19:54'!
test03CartShouldOnlyHaveTheBooksThatWereAdded
	
	| book1 book2 aCartWithBooks|
	
	book1:= '35145645646748'.
	book2:= '6464564564564'.
	
	aCartWithBooks:=  self carrito add: book1 withQuantity: 1.
	aCartWithBooks add: book2 withQuantity: 1.
	
	self assert: (aCartWithBooks hasItem: book1 withQuantity: 1).
	self assert: (aCartWithBooks hasItem: book2 withQuantity: 1).	
	self assert: (aCartWithBooks size = 2)
! !

!TusLibrosTest methodsFor: 'cashier' stamp: 'EmilianoMenendezEzequielNicols 6/3/2013 19:51'!
testCheckoutOfCartWithSingleElementShouldReturnSinglePrice

	|cart aCashier expectedTotal |
	
	aCashier:= Cashier new.
	cart := self carritoConUnLibro.
	expectedTotal :=  aCashier calculateTotal: cart.
	
	self assert: ((aCashier checkOut: cart) = expectedTotal) ! !

!TusLibrosTest methodsFor: 'cashier' stamp: 'EmilianoMenendezEzequielNicols 6/4/2013 18:48'!
testCheckoutOfEmptyCartShouldNotAddNewSale
	| aCart aCashier newSale purchaseTotal |

	aCart := self carritoConUnLibro.
	aCashier := Cashier newCashier.
	purchaseTotal := aCashier calculateTotal: aCart.
	newSale := Ticket newFrom: aCart withTotal: purchaseTotal.
	
	self deny: (aCashier libroDeVentas includes: newSale)! !

!TusLibrosTest methodsFor: 'cashier' stamp: 'EmilianoMenendezEzequielNicols 5/29/2013 20:48'!
testCheckoutOfEmptyCartShouldRaiseAnError

	|emptyCart aCashier|

	emptyCart := Cart newCartWithCatalog: Bag new.
      aCashier := Cashier new. 

 	self should: [aCashier checkOut: emptyCart ] 
		raise: Error 
		withExceptionDo: [ :anError |  self assert: anError messageText = Cashier cantCheckoutEmptyCartMessage]  ! !

!TusLibrosTest methodsFor: 'cashier' stamp: 'EmilianoMenendezEzequielNicols 6/3/2013 20:51'!
testCheckoutWithExpiredCardDoesNotCallTheMerchantProcessor

	|cashier|
	
	cashier := self cajeroWith: MerchantProcessorExpiredCard new.
	
	self should: [cashier checkOut: self carritoConUnLibro payingWith: self tarjetaVencida]
	raise: Error
	withExceptionDo: [:anError | self assert: anError messageText equals: 'EXPIRED_CARD' ]! !

!TusLibrosTest methodsFor: 'cashier' stamp: 'EmilianoMenendezEzequielNicols 6/5/2013 19:39'!
testCheckoutWithStolenCardShouldRejectTransaction

	|cashier stolenCreditCardResult |
	
	"stolenCreditCardResult := Error message new: 'STOLEN_CARD'."
	cashier := self cajeroWith: (MerchantProcessorStub newWith: [Error signal: 'Card was stolen.']).
	
	self should: [cashier checkOut: self carritoConUnLibro payingWith: self tarjetaNoVencida ]
	raise: Error
	withExceptionDo: [:anError | self assert: anError messageText equals: 'Card was stolen.' ]! !

!TusLibrosTest methodsFor: 'interface' stamp: 'EmilianoMenendezEzequielNicols 6/5/2013 21:37'!
testCreateCartWithValidCredentialsShouldReturnANewCart

	| interface cartId cart |

	interface := TusLibrosInterface newWithSecurityGuard: self securityGuard.

	cartId := interface createCartFor: 'pepe' usingPassword: '1234'.
	
	cart := (self sessions at: cartId) cart
	
	self assert: self  ! !

!TusLibrosTest methodsFor: 'Credit Card Tests' stamp: 'EmilianoMenendezEzequielNicols 6/2/2013 17:23'!
testCreatingACreditCardWithDataOKShouldReturnTheCard

	| creditCard expectedNumber expectedOwner expectedExpirationDate |
	
	expectedNumber := '1234'.
	expectedOwner := 'Homero Simpson'.
	expectedExpirationDate := Date tomorrow.
	
	creditCard := CreditCard newWithNumber: expectedNumber andOwner: expectedOwner andExpirationDate: expectedExpirationDate.
	
	self assert: creditCard number equals: expectedNumber.
	self assert: creditCard owner equals: expectedOwner.
	self assert: creditCard expirationDate equals: expectedExpirationDate.! !

!TusLibrosTest methodsFor: 'Credit Card Tests' stamp: 'EmilianoMenendezEzequielNicols 6/2/2013 17:23'!
testCreatingACreditCardWithEmptyNumberShouldRaiseAnError

	 self should: [CreditCard newWithNumber: '' andOwner: 'Homero Simpson' andExpirationDate: Date tomorrow] 
		raise: Error 
		withExceptionDo: [ :anError |  self assert: anError messageText = 'Credit card number cannot be empty.'] ! !

!TusLibrosTest methodsFor: 'Credit Card Tests' stamp: 'EmilianoMenendezEzequielNicols 6/2/2013 17:23'!
testCreatingACreditCardWithEmptyOwnerNameShouldRaiseAnError

	 self should: [CreditCard newWithNumber: '1234' andOwner: '' andExpirationDate: Date tomorrow] 
		raise: Error 
		withExceptionDo: [ :anError |  self assert: anError messageText = 'Credit card owner cannot be empty.'] ! !

!TusLibrosTest methodsFor: 'Credit Card Tests' stamp: 'EmilianoMenendezEzequielNicols 6/2/2013 17:23'!
testCreatingACreditCardWithOwnerNameLengthGreaterThan30ShouldRaiseAnError

	 self should: [CreditCard newWithNumber: '1234' andOwner: '123456789_123456789_123456789_1' andExpirationDate: Date tomorrow] 
		raise: Error 
		withExceptionDo: [ :anError |  self assert: anError messageText = 'Credit card owner cannot be greater than 30 characters long.'] ! !

!TusLibrosTest methodsFor: 'security' stamp: 'EmilianoMenendezEzequielNicols 6/5/2013 21:14'!
testSuccessfulUserAuthenticationShouldReturnAToken
	| token |

	token := self securityGuard validate: 'pepe' with: '1234'.

	self assert: token > 0.! !

!TusLibrosTest methodsFor: 'security' stamp: 'EmilianoMenendezEzequielNicols 6/5/2013 21:19'!
testTryingToAuthenticateInvalidUserNameShouldRaiseError

	self should: [self securityGuard validate: 'not_a_user' with: '1234'] raise: Error withExceptionDo: [ :anError | self assert: anError messageText = 'Invalid User or Password.' ]
! !

!TusLibrosTest methodsFor: 'security' stamp: 'EmilianoMenendezEzequielNicols 6/5/2013 21:20'!
testTryingToAuthenticateUserWithInvalidPasswordShouldRaiseError

	self should: [self securityGuard validate: 'pepe' with: 'wrong_password'] raise: Error withExceptionDo: [ :anError | self assert: anError messageText = 'Invalid User or Password.' ]! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielNicols 6/5/2013 21:23'!
userRegistry
	
	|userRegistry |
	
	userRegistry := Dictionary  new.
	userRegistry at:'pepe' put:'1234'.
	^userRegistry 
	! !

Object subclass: #Cart
	instanceVariableNames: 'id items catalogo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!Cart class methodsFor: 'instance-creation' stamp: 'EmilianoMenendezEzequielNicols 5/29/2013 20:13'!
newCartWithCatalog: aCatalog
	^ self new emptyCartWithCatalog: aCatalog! !

!Cart methodsFor: 'adding' stamp: 'EmilianoMenendezEzequielNicols 5/29/2013 20:00'!
add: anISBN 
	
	
	items add: anISBN! !

!Cart methodsFor: 'adding' stamp: 'EmilianoMenendezEzequielNicols 5/31/2013 19:03'!
add: anISBN withQuantity: aQuantity 
	
	
	(catalogo includesKey: anISBN ) ifFalse:[^ Error signal: 'El libro no pertenece al catlogo' ].
	items add: anISBN withOccurrences: aQuantity ! !

!Cart methodsFor: 'testing' stamp: 'EmilianoMenendezEzequielNicols 5/29/2013 20:01'!
catalog

	^catalogo! !

!Cart methodsFor: 'Initializing' stamp: 'EmilianoMenendezEzequielNicols 5/29/2013 19:58'!
emptyCartWithCatalog: aCatalog
	
	items := Bag new.
	catalogo := aCatalog.! !

!Cart methodsFor: 'testing' stamp: 'EmilianoMenendezEzequielNicols 5/29/2013 19:54'!
hasItem: anISBN withQuantity: aQuantity

	^(items occurrencesOf: anISBN) = aQuantity  ! !

!Cart methodsFor: 'testing' stamp: 'EmilianoMenendezEzequielNicols 5/27/2013 21:46'!
isEmpty

	^items isEmpty! !

!Cart methodsFor: 'accessing' stamp: 'EmilianoMenendezEzequielNicols 6/1/2013 15:22'!
itemPrice: anItem 
	
	^catalogo at: anItem! !

!Cart methodsFor: 'accessing' stamp: 'EmilianoEzequielNicols 6/1/2013 16:07'!
itemQuantity: anItem  
	
	^items occurrencesOf: anItem! !

!Cart methodsFor: 'testing' stamp: 'EmilianoEzequielNicols 6/1/2013 16:25'!
items

	^items ! !

!Cart methodsFor: 'testing' stamp: 'EmilianoMenendezEzequielNicols 5/29/2013 19:32'!
size

	^items size! !

Object subclass: #Cashier
	instanceVariableNames: 'libroDeVentas merchantProcessor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!Cashier class methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielNicols 5/29/2013 20:42'!
cantCheckoutEmptyCartMessage
	^ 'Cant checkout an empty cart'! !

!Cashier class methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielNicols 6/2/2013 17:52'!
newCashier
	
	
	^ self new initialize.  ! !

!Cashier class methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielNicols 6/3/2013 20:20'!
newWith: aMerchantProcessor
	
	
	^ self new initializeWith: aMerchantProcessor.  ! !

!Cashier methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielNicols 6/2/2013 17:38'!
calculateTotal: aCart 
	
	|cartItems temporaryTotal|
	
	cartItems := aCart items.
	temporaryTotal := 0.
	
	cartItems do: [ :anItem | temporaryTotal := temporaryTotal + (( aCart itemQuantity: anItem) * (aCart itemPrice: anItem))].
	
	^temporaryTotal.! !

!Cashier methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielNicols 6/3/2013 21:06'!
checkOut: aCart 
	
	|ticketVenta|
	
	ticketVenta := Ticket newFrom: aCart withTotal: (self calculateTotal: aCart).
	
	(aCart isEmpty) ifTrue: [^ Error signal: self class cantCheckoutEmptyCartMessage].
	libroDeVentas add: ticketVenta.
	
	^ticketVenta! !

!Cashier methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielNicols 6/3/2013 21:13'!
checkOut: aCart payingWith: aCreditCard
	| ticket aTotal transactionResult |
	
	aCart isEmpty
		ifTrue: [ ^ Error signal: self class cantCheckoutEmptyCartMessage ].
	(self isExpired: aCreditCard)
		ifTrue: [ ^ Error signal: 'EXPIRED_CARD' ].

	aTotal := self calculateTotal: aCart.
	transactionResult := merchantProcessor debit: aTotal fromCard: aCreditCard.
	ticket := Ticket newFrom: aCart withTotal: aTotal andTransactionResult: transactionResult.
	
	(transactionResult  = CreditCardTransactionResult  ok) ifTrue: [libroDeVentas add: ticket].

	^ ticket! !

!Cashier methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielNicols 6/2/2013 17:53'!
initialize

	libroDeVentas := Bag new.! !

!Cashier methodsFor: 'initializing' stamp: 'EmilianoMenendezEzequielNicols 6/3/2013 20:39'!
initializeWith: aMerchantProcessorStub 
	
	libroDeVentas := Bag new.
	merchantProcessor := aMerchantProcessorStub! !

!Cashier methodsFor: 'accessing' stamp: 'EmilianoMenendezEzequielNicols 6/3/2013 20:53'!
isExpired: aCreditCard

	^ aCreditCard expirationDate < Date today! !

!Cashier methodsFor: 'accessing' stamp: 'EmilianoMenendezEzequielNicols 6/3/2013 19:20'!
libroDeVentas

	^ libroDeVentas! !

Object subclass: #CreditCard
	instanceVariableNames: 'number owner expirationDate'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!CreditCard class methodsFor: 'creation' stamp: 'EmilianoMenendezEzequielNicolas 6/1/2013 17:37'!
newWithNumber: aNumber andOwner: anOwner andExpirationDate: anExpirationDate
	^ self new initializeWithNumber: aNumber andOwner: anOwner andExpirationDate: anExpirationDate.! !

!CreditCard methodsFor: 'accessing' stamp: 'EmilianoMenendezEzequielNicolas 6/1/2013 17:39'!
expirationDate
	^ expirationDate! !

!CreditCard methodsFor: 'creation' stamp: 'EmilianoMenendezEzequielNicolas 6/1/2013 18:45'!
initializeWithNumber: aNumber andOwner: anOwner andExpirationDate: anExpirationDate

	(aNumber trim size = 0) ifTrue: [ ^ Error signal: 'Credit card number cannot be empty.' ].
	(anOwner trim size = 0) ifTrue: [ ^ Error signal: 'Credit card owner cannot be empty.' ].
	(anOwner trim size > 30) ifTrue: [ ^ Error signal: 'Credit card owner cannot be greater than 30 characters long.' ].
	
	number := aNumber trim.
	owner := anOwner.
	expirationDate := anExpirationDate.! !

!CreditCard methodsFor: 'accessing' stamp: 'EmilianoMenendezEzequielNicolas 6/1/2013 17:38'!
number
	^ number! !

!CreditCard methodsFor: 'accessing' stamp: 'EmilianoMenendezEzequielNicolas 6/1/2013 17:39'!
owner
	^ owner! !

Object subclass: #CreditCardTransaction
	instanceVariableNames: 'amount creditCard'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!CreditCardTransaction class methodsFor: 'creation' stamp: 'EmilianoMenendezEzequielNicolas 6/1/2013 18:26'!
newWithAmount: anAmount andCreditCard: aCreditCard 
	^ self new initializeWithAmount: anAmount andCreditCard: aCreditCard.! !

!CreditCardTransaction methodsFor: 'accessing' stamp: 'EmilianoMenendezEzequielNicolas 6/1/2013 18:29'!
amount
	^ amount! !

!CreditCardTransaction methodsFor: 'accessing' stamp: 'EmilianoMenendezEzequielNicolas 6/1/2013 18:30'!
creditCard
	^ creditCard! !

!CreditCardTransaction methodsFor: 'creation' stamp: 'EmilianoMenendezEzequielNicolas 6/1/2013 18:28'!
initializeWithAmount: anAmount andCreditCard: aCreditCard 
	amount := anAmount.
	creditCard := aCreditCard.! !

Object subclass: #MerchantProcessorStub
	instanceVariableNames: 'result'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!MerchantProcessorStub class methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielNicols 6/3/2013 20:15'!
newWith: aResult

	^self new initializeWith: aResult ! !

!MerchantProcessorStub methodsFor: 'operation' stamp: 'EmilianoMenendezEzequielNicols 6/5/2013 19:14'!
debit: anAmount fromCard: aCreditCard
	
	^ result value! !

!MerchantProcessorStub methodsFor: 'creation' stamp: 'EmilianoMenendezEzequielNicols 6/3/2013 20:14'!
initializeWith: aResult
	
	result := aResult! !

Object subclass: #SecurityGuard
	instanceVariableNames: 'userRegistry'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!SecurityGuard class methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielNicols 6/5/2013 20:09'!
newWith: aRegistry

	^self new initializeWith: aRegistry! !

!SecurityGuard methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielNicols 6/5/2013 20:10'!
initializeWith: aRegistry

	userRegistry:= aRegistry ! !

!SecurityGuard methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielNicols 6/5/2013 21:16'!
validate: aUser with: aPassword

	((userRegistry includesKey: aUser) and: [(userRegistry at: aUser ) = aPassword ]) ifTrue: [^ Random new nextInt: 10000000].
	^ Error signal: 'Invalid User or Password.'! !

Object subclass: #Session
	instanceVariableNames: 'creationTime cart'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

Object subclass: #Ticket
	instanceVariableNames: 'items total transactionResult'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!Ticket class methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielNicols 6/3/2013 21:05'!
newFrom: aCart withTotal: anAmount
	^ Ticket new initializeWith: aCart andTotal: anAmount andTransactionResult: aResult! !

!Ticket methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielNicols 6/4/2013 21:11'!
addCartItems: aCart 
	
	|ticketItems|
	
	ticketItems := OrderedCollection new: aCart items size.
	
! !

!Ticket methodsFor: 'initializing' stamp: 'EmilianoMenendezEzequielNicols 6/4/2013 19:20'!
initializeWith: aCart andTotal: anAmount andTransactionResult: anObject
	
	
	items :=  self addCartItems: aCart.
	total := anAmount.
	! !

!Ticket methodsFor: 'accessing' stamp: 'EmilianoMenendezEzequielNicols 6/1/2013 14:36'!
total
	^ total! !

Object subclass: #TusLibrosInterface
	instanceVariableNames: 'securityGuard carts'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!
